from flask import Flask, render_template, request, redirect, url_for
import sqlite3
import uuid

app = Flask(__name__)

connect = sqlite3.connect("eShop_database.db")
cursor = connect.cursor()

cursor.execute('''DROP TABLE Basket''')
try:
    cursor.execute('''CREATE TABLE Items (id integer, name text, price text, description text, image_filename text, volume text)''')
    cursor.execute('''INSERT INTO Items (id, name, price, description, image_filename, volume) VALUES (0, 'AK47', '£125', 'Russian manufactured rifle with a high fire rate and penetration. This absolute classic is popular amongst our regular customers and we are sure that you will fall in love with it too. 30 rounds per magazine and strong recoil. On the noisy side.', 'ak47.png', '140dB')''')
    cursor.execute('''INSERT INTO Items (id, name, price, description, image_filename, volume) VALUES (1, 'M4A4', '£110', 'Accurate rifle with a 70mm barrel and a telescoping stock.', 'm4a4.png', '130dB')''')
    cursor.execute('''INSERT INTO Items (id, name, price, description, image_filename, volume) VALUES (2, 'M4A1S', '£150', 'M4A4 silenced counterpart with less recoil but smaller magazine size.', 'm4a1s.png', '100dB')''')
    cursor.execute('''INSERT INTO Items (id, name, price, description, image_filename, volume) VALUES (3, 'SSG08', '£220', 'Lightweight sniper rifle with high accuracy and low recoil. 10 rounds per magazine', 'ssg08.png', '140dB')''')
except: pass
try:
    cursor.execute('''CREATE TABLE Basket (id text, AK47 integer, M4A4 integer, M4A1S integer, SSG08 integer)''')
    connect.commit()
except: pass
global customerID
customerID = str(uuid.uuid4())
cursor.execute('INSERT INTO Basket (id, AK47, M4A4, M4A1S, SSG08) VALUES (?, 0, 0, 0, 0)', (customerID,))
connect.commit()

cursor.execute('''SELECT name, price, description, image_filename, volume FROM Items''')
rows = cursor.fetchall()
technologies = []
for row in rows:
    current_technology = {
        "name": row[0],
        "price": row[1],
        "description": row[2],
        "image_filename": row[3],
        "volume": row[4]
        }
    technologies.append(current_technology)
    

@app.route('/', methods=["GET", "POST"])
def galleryPage():
    return render_template("index.html", technologies = technologies)

@app.route('/tech/<int:techId>')
def singleProductPage(techId):
    return render_template("SingleTech.html", technology = technologies[techId])

@app.route('/basketPage')
def basketPage():
    connect = sqlite3.connect("eShop_database.db")
    cursor = connect.cursor()
    cursor.execute(f'SELECT * FROM Basket WHERE id = ?', (customerID,))
    row = cursor.fetchone()
    quantities = {
        'AK-47': row[1],
        'M4A4': row[2],
        'M4A1-S': row[3],
        'SSG 08': row[4]
    }
    return render_template("Basket.html", quantities=quantities)

@app.route('/update_basket', methods=['POST'])
def update_basket():
    connect = sqlite3.connect("eShop_database.db")
    cursor = connect.cursor()
    quantity = int(request.form.get("quantity"))
    itemName = request.form.get("itemName")
    cursor.execute(f'SELECT {itemName} FROM Basket WHERE id = ?', (customerID,))
    current_quantity = cursor.fetchone()[0] 
    new_quantity = current_quantity + quantity
    cursor.execute(f'UPDATE Basket SET "{itemName}" = ? WHERE id = ?', (new_quantity, customerID))
    connect.commit()
    return redirect(url_for('galleryPage'))

if __name__ == '__main__':
    app.run(debug=True)
